#!/usr/bin/perl
#	@(#) gen-initial-newsgroups.pl - Create newsgroup directories from "newsgroups" file
#
# $Id: gen-initial-newsgroups.pl,v 1.1 2002/05/21 13:50:35 cvs Exp $
#
# Usage:	gen-initial-newsgroups.pl data/ausgroups

use lib 'bin';

use Newsgroup;

my $newsgroups_file = shift @ARGV || usage();

open(F, "<$newsgroups_file") or die "Unable to open $newsgroups_file for reading: $!";

while (<F>) {
	chomp;
	my($group,$description) = ($_ =~ /^(\S+)\s+(.+)/);

	if ($group eq '' || $description eq '') {
		print "Invalid line (ignored): $_\n";
		next;
	}

	my $ng = new Newsgroup(name => $group);
	$ng->create();
	$ng->set_attr('ngline', "$description\n");
}

close(F);

exit(0);

sub usage {
	die "Usage: gen-initial-newsgroups.pl data/ausgroups\n";
}
